Index: src/LinearAlgebra/Makefile.am
===================================================================
--- src/LinearAlgebra/Makefile.am	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/Makefile.am	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,89 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+INCLUDES = -I$(top_srcdir)/src
+
+AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
+# Position-Independent Code necessary for shared library
+AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
+
+LINALGSOURCE = \
+  ${HELPERSOURCE} \
+  BoxVector.cpp \
+  gslmatrix.cpp \
+  gslvector.cpp \
+  Line.cpp \
+  LineSegment.cpp \
+  LineSegmentSet.cpp \
+  linearsystemofequations.cpp \
+  Matrix.cpp \
+  Plane.cpp \
+  Space.cpp \
+  vector_ops.cpp \
+  Vector.cpp \
+  VectorInterface.cpp
+			   
+LINALGHEADER = \
+  BoxVector.hpp \
+  gslmatrix.hpp \
+  gslvector.hpp \
+  Line.hpp \
+  LineSegment.hpp \
+  LineSegmentSet.hpp \
+  linearsystemofequations.hpp \
+  Matrix.hpp \
+  Plane.hpp \
+  Space.hpp \
+  vector_ops.hpp \
+  Vector.hpp \
+  VectorInterface.hpp
+
+
+lib_LTLIBRARIES = libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la
+libMolecuilderLinearAlgebra_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+libMolecuilderLinearAlgebra_libs = ../Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la $(GSL_LIBS)
+nobase_libMolecuilderLinearAlgebra_include_HEADERS = ${LINALGHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilderLinearAlgebra_@MOLECUILDER_API_VERSION@_la_SOURCES = ${LINALGSOURCE}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilderLinearAlgebra_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderLinearAlgebra_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilderLinearAlgebra_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
+unity.cpp:
+	echo "" >  unity.cpp; \
+	list='$(LINALGSOURCE)'; for file in $$list; do \
+	  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done;
+	
+MOSTLYCLEANFILES = unity.cpp
Index: src/LinearAlgebra/Matrix.cpp
===================================================================
--- src/LinearAlgebra/Matrix.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/Matrix.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,357 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Matrix.cpp
+ *
+ *  Created on: Jun 25, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "LinearAlgebra/Matrix.hpp"
+#include "Helpers/Assert.hpp"
+#include "Exceptions/NotInvertibleException.hpp"
+#include "Helpers/fast_functions.hpp"
+#include "Helpers/Assert.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "VectorContent.hpp"
+#include "MatrixContent.hpp"
+
+#include <gsl/gsl_blas.h>
+#include <gsl/gsl_eigen.h>
+#include <gsl/gsl_matrix.h>
+#include <gsl/gsl_multimin.h>
+#include <gsl/gsl_vector.h>
+#include <cmath>
+#include <iostream>
+
+using namespace std;
+
+Matrix::Matrix()
+{
+  content = new MatrixContent();
+  content->content = gsl_matrix_calloc(NDIM, NDIM);
+  createViews();
+}
+
+Matrix::Matrix(const double* src){
+  content = new MatrixContent();
+  content->content = gsl_matrix_alloc(NDIM, NDIM);
+  set(0,0, src[0]);
+  set(1,0, src[1]);
+  set(2,0, src[2]);
+
+  set(0,1, src[3]);
+  set(1,1, src[4]);
+  set(2,1, src[5]);
+
+  set(0,2, src[6]);
+  set(1,2, src[7]);
+  set(2,2, src[8]);
+  createViews();
+}
+
+Matrix::Matrix(const Matrix &src){
+  content = new MatrixContent();
+  content->content = gsl_matrix_alloc(NDIM, NDIM);
+  gsl_matrix_memcpy(content->content,src.content->content);
+  createViews();
+}
+
+Matrix::Matrix(MatrixContent* _content) :
+  content(_content)
+{
+  createViews();
+}
+
+Matrix::~Matrix()
+{
+  // delete all views
+  for(int i=NDIM;i--;){
+    delete rows_ptr[i];
+  }
+  for(int i=NDIM;i--;){
+    delete columns_ptr[i];
+  }
+  delete diagonal_ptr;
+  gsl_matrix_free(content->content);
+  delete content;
+}
+
+void Matrix::createViews(){
+  // create row views
+  for(int i=NDIM;i--;){
+    VectorContent *rowContent = new VectorViewContent(gsl_matrix_row(content->content,i));
+    rows_ptr[i] = new Vector(rowContent);
+  }
+  // create column views
+  for(int i=NDIM;i--;){
+    VectorContent *columnContent = new VectorViewContent(gsl_matrix_column(content->content,i));
+    columns_ptr[i] = new Vector(columnContent);
+  }
+  // create diagonal view
+  VectorContent *diagonalContent = new VectorViewContent(gsl_matrix_diagonal(content->content));
+  diagonal_ptr = new Vector(diagonalContent);
+}
+
+void Matrix::one(){
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      set(i,j,i==j);
+    }
+  }
+}
+
+void Matrix::zero(){
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      set(i,j,0.);
+    }
+  }
+}
+
+void Matrix::rotation(const double x, const double y, const double z)
+{
+  set(0,0, cos(y)*cos(z));
+  set(0,1, cos(z)*sin(x)*sin(y) - cos(x)*sin(z));
+  set(0,2, cos(x)*cos(z)*sin(y) + sin(x) * sin(z));
+  set(1,0, cos(y)*sin(z));
+  set(1,1, cos(x)*cos(z) + sin(x)*sin(y)*sin(z));
+  set(1,2, -cos(z)*sin(x) + cos(x)*sin(y)*sin(z));
+  set(2,0, -sin(y));
+  set(2,1, cos(y)*sin(x));
+  set(2,2, cos(x)*cos(y));
+}
+
+Matrix &Matrix::operator=(const Matrix &src){
+  if(&src!=this){
+    gsl_matrix_memcpy(content->content,src.content->content);
+  }
+  return *this;
+}
+
+const Matrix &Matrix::operator+=(const Matrix &rhs){
+  gsl_matrix_add(content->content, rhs.content->content);
+  return *this;
+}
+
+const Matrix &Matrix::operator-=(const Matrix &rhs){
+  gsl_matrix_sub(content->content, rhs.content->content);
+  return *this;
+}
+
+const Matrix &Matrix::operator*=(const Matrix &rhs){
+  (*this) = (*this)*rhs;
+  return *this;
+}
+
+const Matrix Matrix::operator+(const Matrix &rhs) const{
+  Matrix tmp = *this;
+  tmp+=rhs;
+  return tmp;
+}
+
+const Matrix Matrix::operator-(const Matrix &rhs) const{
+  Matrix tmp = *this;
+  tmp-=rhs;
+  return tmp;
+}
+
+const Matrix Matrix::operator*(const Matrix &rhs) const{
+  gsl_matrix *res = gsl_matrix_alloc(NDIM, NDIM);
+  gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, content->content, rhs.content->content, 0.0, res);
+  MatrixContent *content= new MatrixContent();
+  content->content = res;
+  return Matrix(content);
+}
+
+double &Matrix::at(size_t i, size_t j){
+  ASSERT(i>=0&&i<NDIM,"Index i for Matrix access out of range");
+  ASSERT(j>=0&&j<NDIM,"Index j for Matrix access out of range");
+  return *gsl_matrix_ptr (content->content, i, j);
+}
+
+const double Matrix::at(size_t i, size_t j) const{
+  ASSERT(i>=0&&i<NDIM,"Index i for Matrix access out of range");
+  ASSERT(j>=0&&j<NDIM,"Index j for Matrix access out of range");
+  return gsl_matrix_get(content->content, i, j);
+}
+
+Vector &Matrix::row(size_t i){
+  ASSERT(i>=0&&i<NDIM,"Index i for Matrix access out of range");
+  return *rows_ptr[i];
+}
+
+const Vector &Matrix::row(size_t i) const{
+  ASSERT(i>=0&&i<NDIM,"Index i for Matrix access out of range");
+  return *rows_ptr[i];
+}
+
+Vector &Matrix::column(size_t i){
+  ASSERT(i>=0&&i<NDIM,"Index i for Matrix access out of range");
+  return *columns_ptr[i];
+}
+
+const Vector &Matrix::column(size_t i) const{
+  ASSERT(i>=0&&i<NDIM,"Index i for Matrix access out of range");
+  return *columns_ptr[i];
+}
+
+Vector &Matrix::diagonal(){
+  return *diagonal_ptr;
+}
+
+const Vector &Matrix::diagonal() const{
+  return *diagonal_ptr;
+}
+
+void Matrix::set(size_t i, size_t j, const double value){
+  ASSERT(i>=0&&i<NDIM,"Index i for Matrix access out of range");
+  ASSERT(j>=0&&j<NDIM,"Index j for Matrix access out of range");
+  gsl_matrix_set(content->content,i,j,value);
+}
+
+double Matrix::determinant() const{
+  return at(0,0)*at(1,1)*at(2,2)
+       + at(0,1)*at(1,2)*at(2,0)
+       + at(0,2)*at(1,0)*at(2,1)
+       - at(2,0)*at(1,1)*at(0,2)
+       - at(2,1)*at(1,2)*at(0,0)
+       - at(2,2)*at(1,0)*at(0,1);
+}
+
+
+Matrix Matrix::invert() const{
+  double det = determinant();
+  if(fabs(det)<MYEPSILON){
+    throw NotInvertibleException(__FILE__,__LINE__);
+  }
+
+  double detReci = 1./det;
+  Matrix res;
+  res.set(0,0,  detReci*RDET2(at(1,1),at(2,1),at(1,2),at(2,2)));    // A_11
+  res.set(1,0, -detReci*RDET2(at(1,0),at(2,0),at(1,2),at(2,2)));    // A_21
+  res.set(2,0,  detReci*RDET2(at(1,0),at(2,0),at(1,1),at(2,1)));    // A_31
+  res.set(0,1, -detReci*RDET2(at(0,1),at(2,1),at(0,2),at(2,2)));    // A_12
+  res.set(1,1,  detReci*RDET2(at(0,0),at(2,0),at(0,2),at(2,2)));    // A_22
+  res.set(2,1, -detReci*RDET2(at(0,0),at(2,0),at(0,1),at(2,1)));    // A_32
+  res.set(0,2,  detReci*RDET2(at(0,1),at(1,1),at(0,2),at(1,2)));    // A_13
+  res.set(1,2, -detReci*RDET2(at(0,0),at(1,0),at(0,2),at(1,2)));    // A_23
+  res.set(2,2,  detReci*RDET2(at(0,0),at(1,0),at(0,1),at(1,1)));    // A_33
+  return res;
+}
+
+Matrix Matrix::transpose() const{
+  MatrixContent *newContent = new MatrixContent();
+  newContent->content = gsl_matrix_alloc(NDIM, NDIM);
+  gsl_matrix_transpose_memcpy(newContent->content, content->content);
+  Matrix res = Matrix(newContent);
+  return res;
+}
+
+Matrix &Matrix::transpose()
+{
+  double tmp;
+  for (int i=0;i<NDIM;i++)
+    for (int j=i+1;j<NDIM;j++) {
+      tmp = at(j,i);
+      at(j,i) = at(i,j);
+      at(i,j) = tmp;
+    }
+  return *this;
+}
+
+
+Vector Matrix::transformToEigenbasis()
+{
+  gsl_eigen_symmv_workspace *T = gsl_eigen_symmv_alloc(NDIM);
+  gsl_vector *eval = gsl_vector_alloc(NDIM);
+  gsl_matrix *evec = gsl_matrix_alloc(NDIM, NDIM);
+  gsl_eigen_symmv(content->content, eval, evec, T);
+  gsl_eigen_symmv_free(T);
+  gsl_matrix_memcpy(content->content, evec);
+  gsl_matrix_free(evec);
+  Vector evalues(gsl_vector_get(eval,0), gsl_vector_get(eval,1), gsl_vector_get(eval,2));
+  gsl_vector_free(eval);
+  return evalues;
+}
+
+const Matrix &Matrix::operator*=(const double factor){
+  gsl_matrix_scale(content->content, factor);
+  return *this;
+}
+
+const Matrix operator*(const double factor,const Matrix& mat){
+  Matrix tmp = mat;
+  tmp*=factor;
+  return tmp;
+}
+
+const Matrix operator*(const Matrix &mat,const double factor){
+  return factor*mat;
+}
+
+bool Matrix::operator==(const Matrix &rhs) const{
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      if(fabs(at(i,j)-rhs.at(i,j))>MYEPSILON){
+        return false;
+      }
+    }
+  }
+  return true;
+}
+
+/** Blows the 6-dimensional \a cell_size array up to a full NDIM by NDIM matrix.
+ * \param *symm 6-dim array of unique symmetric matrix components
+ * \return allocated NDIM*NDIM array with the symmetric matrix
+ */
+Matrix ReturnFullMatrixforSymmetric(const double * const symm)
+{
+  Matrix matrix;
+  matrix.set(0,0, symm[0]);
+  matrix.set(1,0, symm[1]);
+  matrix.set(2,0, symm[3]);
+  matrix.set(0,1, symm[1]);
+  matrix.set(1,1, symm[2]);
+  matrix.set(2,1, symm[4]);
+  matrix.set(0,2, symm[3]);
+  matrix.set(1,2, symm[4]);
+  matrix.set(2,2, symm[5]);
+  return matrix;
+};
+
+ostream &operator<<(ostream &ost,const Matrix &mat){
+  for(int i = 0;i<NDIM;++i){
+    ost << "\n";
+    for(int j = 0; j<NDIM;++j){
+      ost << mat.at(i,j);
+      if(j!=NDIM-1)
+        ost << "; ";
+    }
+  }
+  return ost;
+}
+
+Vector operator*(const Matrix &mat,const Vector &vec){
+  Vector res;
+  gsl_blas_dgemv( CblasNoTrans, 1.0, mat.content->content, vec.content->content, 0.0, res.content->content);
+  return res;
+}
+
+Vector &operator*=(Vector& lhs,const Matrix &mat){
+  lhs = mat*lhs;
+  return lhs;
+}
+
Index: src/LinearAlgebra/Matrix.hpp
===================================================================
--- src/LinearAlgebra/Matrix.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/Matrix.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,172 @@
+/*
+ * Matrix.hpp
+ *
+ *  Created on: Jun 25, 2010
+ *      Author: crueger
+ */
+
+#ifndef MATRIX_HPP_
+#define MATRIX_HPP_
+
+#include <iosfwd>
+#include "defs.hpp"
+
+/**
+ * Simple class to store matrices with a few extra functions
+ */
+
+class Vector;
+class MatrixContent;
+
+class Matrix
+{
+  friend Vector operator*(const Matrix&,const Vector&);
+public:
+  Matrix();
+
+  /**
+   * construct a matrix from a 3x3 double array that contains all Elements.
+   *
+   * The elements are laid out in the following way:
+   * array -> matrix
+   * 0 -> (0,0)
+   * 1 -> (1,0)
+   * 2 -> (2,0)
+   * 3 -> (0,1)
+   * 4 -> (1,1)
+   * 5 -> (2,1)
+   * 6 -> (0,2)
+   * 7 -> (1,2)
+   * 8 -> (2,2)
+   *
+   */
+  Matrix(const double*);
+  Matrix(const Matrix&);
+  virtual ~Matrix();
+
+  /**
+   * Set the matrix to a unit matrix.
+   */
+  void one();
+
+  /**
+   * Set all matrix entries to zero.
+   */
+  void zero();
+
+  /**
+   * Sets all matrix corresponding to a rotation matrix,
+   * first around the x-, then the y-, finally the z-axis
+   * with given angles.
+   */
+  void rotation(const double x, const double y, const double z);
+
+  /**
+   * Access the matrix at index (i,j)
+   */
+  double &at(size_t i, size_t j);
+  /**
+   * Access the matrix at index (i,j)
+   */
+  const double at(size_t i, size_t j) const;
+
+  /**
+   * Set the matrix at index (i,j).
+   *
+   * Slightly faster than at(i,j)=x
+   */
+  void set(size_t i, size_t j, const double value);
+
+  /**
+   * get the ith row of the matrix as a vector
+   */
+  Vector &row(size_t);
+  const Vector &row(size_t) const;
+
+  /**
+   * get the ith column of the matrix as a vector
+   */
+  Vector &column(size_t);
+  const Vector &column(size_t) const;
+
+  /**
+   * get the diagonal of the matrix as a vector
+   */
+  Vector &diagonal();
+  const Vector &diagonal() const;
+
+  /**
+   * Calculate the determinant of the matrix
+   */
+  double determinant() const;
+
+  /**
+   * Calculate the inverse of the matrix.
+   *
+   * Rather costly, so use precomputation as often as possible.
+   */
+  Matrix invert() const;
+
+  /**
+   * Diagonalizes a matrix and sets its rows to the resulting eigenvalues.
+   * The eigenvalues are returned as a vector.
+   *
+   * Rather costly, so use precomputation as often as possible.
+   */
+  Vector transformToEigenbasis();
+
+  /**
+   * Calculate the transpose of the matrix.
+   */
+  Matrix transpose() const;
+  Matrix &transpose();
+
+  // operators
+  Matrix &operator=(const Matrix&);
+
+  const Matrix &operator+=(const Matrix&);
+  const Matrix &operator-=(const Matrix&);
+  const Matrix &operator*=(const Matrix&);
+
+  const Matrix &operator*=(const double);
+
+  const Matrix operator+(const Matrix&) const;
+  const Matrix operator-(const Matrix&) const;
+  const Matrix operator*(const Matrix&) const;
+
+  bool operator==(const Matrix&) const;
+
+private:
+  Matrix(MatrixContent*);
+  void createViews();
+  MatrixContent *content;
+  // we keep around some Vector views of the matrix, to return references
+  Vector* rows_ptr[NDIM];
+  Vector* columns_ptr[NDIM];
+  Vector* diagonal_ptr;
+};
+
+const Matrix operator*(const double,const Matrix&);
+const Matrix operator*(const Matrix&,const double);
+
+/**
+ * Takes a symmetric matrix that stores the lower diagonal and produces a
+ * full matrix.
+ *
+ * The array is laid out as follows:
+ *
+ * array -> matrix
+ * 0 -> (0,0)
+ * 1 -> (1,0);(0,1)
+ * 2 -> (1,1)
+ * 3 -> (2,0);(0,2)
+ * 4 -> (2,1);(1,2)
+ * 5 -> (2,2)
+ */
+Matrix ReturnFullMatrixforSymmetric(const double * const cell_size);
+
+std::ostream &operator<<(std::ostream&,const Matrix&);
+Vector operator*(const Matrix&,const Vector&);
+Vector& operator*=(Vector&,const Matrix&);
+
+#endif /* MATRIX_HPP_ */
Index: src/LinearAlgebra/MatrixContent.hpp
===================================================================
--- src/LinearAlgebra/MatrixContent.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/MatrixContent.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * MatrixContent.hpp
+ *
+ *  Created on: Jul 2, 2010
+ *      Author: crueger
+ */
+
+#ifndef MATRIXCONTENT_HPP_
+#define MATRIXCONTENT_HPP_
+
+/**
+ * !file
+ * The way GSL works does not allow for forward definitions of the structures.
+ * Because of this the pointer to the gsl_matrix struct is wrapped inside another
+ * (dumb) object that allows for forward definitions. All methods of this class
+ * are empty, to allow for a maximum of flexibility.
+ */
+
+#include <gsl/gsl_matrix.h>
+
+struct MatrixContent{
+  gsl_matrix * content;
+};
+
+#endif /* MATRIXCONTENT_HPP_ */
Index: src/LinearAlgebra/Plane.cpp
===================================================================
--- src/LinearAlgebra/Plane.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/Plane.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,242 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Plane.cpp
+ *
+ *  Created on: Apr 7, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "LinearAlgebra/Plane.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "defs.hpp"
+#include "Helpers/Info.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Assert.hpp"
+#include "Helpers/helpers.hpp"
+#include <cmath>
+#include "LinearAlgebra/Line.hpp"
+#include "Exceptions/MultipleSolutionsException.hpp"
+
+/**
+ * generates a plane from three given vectors defining three points in space
+ */
+Plane::Plane(const Vector &y1, const Vector &y2, const Vector &y3) throw(LinearDependenceException) :
+  normalVector(new Vector())
+{
+  Vector x1 = y1 -y2;
+  Vector x2 = y3 -y2;
+  if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(x2)) < MYEPSILON)) {
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+//  Log() << Verbose(4) << "relative, first plane coordinates:";
+//  x1.Output((ofstream *)&cout);
+//  Log() << Verbose(0) << endl;
+//  Log() << Verbose(4) << "second plane coordinates:";
+//  x2.Output((ofstream *)&cout);
+//  Log() << Verbose(0) << endl;
+
+  normalVector->at(0) = (x1[1]*x2[2] - x1[2]*x2[1]);
+  normalVector->at(1) = (x1[2]*x2[0] - x1[0]*x2[2]);
+  normalVector->at(2) = (x1[0]*x2[1] - x1[1]*x2[0]);
+  normalVector->Normalize();
+
+  offset=normalVector->ScalarProduct(y1);
+}
+/**
+ * Constructs a plane from two direction vectors and a offset.
+ */
+Plane::Plane(const Vector &y1, const Vector &y2, double _offset) throw(ZeroVectorException,LinearDependenceException) :
+    normalVector(new Vector()),
+    offset(_offset)
+{
+  Vector x1 = y1;
+  Vector x2 = y2;
+  if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON)) {
+    throw ZeroVectorException(__FILE__,__LINE__);
+  }
+
+  if((fabs(x1.Angle(x2)) < MYEPSILON)) {
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+//  Log() << Verbose(4) << "relative, first plane coordinates:";
+//  x1.Output((ofstream *)&cout);
+//  Log() << Verbose(0) << endl;
+//  Log() << Verbose(4) << "second plane coordinates:";
+//  x2.Output((ofstream *)&cout);
+//  Log() << Verbose(0) << endl;
+
+  normalVector->at(0) = (x1[1]*x2[2] - x1[2]*x2[1]);
+  normalVector->at(1) = (x1[2]*x2[0] - x1[0]*x2[2]);
+  normalVector->at(2) = (x1[0]*x2[1] - x1[1]*x2[0]);
+  normalVector->Normalize();
+}
+
+Plane::Plane(const Vector &_normalVector, double _offset) throw(ZeroVectorException):
+  normalVector(new Vector(_normalVector)),
+  offset(_offset)
+{
+  if(normalVector->IsZero())
+    throw ZeroVectorException(__FILE__,__LINE__);
+  double factor = 1/normalVector->Norm();
+  // normalize the plane parameters
+  (*normalVector)*=factor;
+  offset*=factor;
+}
+
+Plane::Plane(const Vector &_normalVector, const Vector &_offsetVector) throw(ZeroVectorException):
+    normalVector(new Vector(_normalVector))
+{
+  if(normalVector->IsZero()){
+    throw ZeroVectorException(__FILE__,__LINE__);
+  }
+  normalVector->Normalize();
+  offset = normalVector->ScalarProduct(_offsetVector);
+}
+
+/**
+ * copy constructor
+ */
+Plane::Plane(const Plane& plane) :
+  normalVector(new Vector(*plane.normalVector)),
+  offset(plane.offset)
+{}
+
+
+Plane::~Plane()
+{}
+
+Plane &Plane::operator=(const Plane &rhs){
+  if(&rhs!=this){
+    normalVector.reset(new Vector(*rhs.normalVector));
+    offset = rhs.offset;
+  }
+  return *this;
+}
+
+
+Vector Plane::getNormal() const{
+  return *normalVector;
+}
+
+double Plane::getOffset() const{
+  return offset;
+}
+
+Vector Plane::getOffsetVector() const {
+  return getOffset()*getNormal();
+}
+
+vector<Vector> Plane::getPointsOnPlane() const{
+  std::vector<Vector> res;
+  res.reserve(3);
+  // first point on the plane
+  res.push_back(getOffsetVector());
+  // get a vector that has direction of plane
+  Vector direction;
+  direction.GetOneNormalVector(getNormal());
+  res.push_back(res[0]+direction);
+  // get an orthogonal vector to direction and normal (has direction of plane)
+  direction.VectorProduct(getNormal());
+  direction.Normalize();
+  res.push_back(res[0] +direction);
+  return res;
+}
+
+
+/** Calculates the intersection point between a line defined by \a *LineVector and \a *LineVector2 and a plane defined by \a *Normal and \a *PlaneOffset.
+ * According to [Bronstein] the vectorial plane equation is:
+ *   -# \f$\stackrel{r}{\rightarrow} \cdot \stackrel{N}{\rightarrow} + D = 0\f$,
+ * where \f$\stackrel{r}{\rightarrow}\f$ is the vector to be testet, \f$\stackrel{N}{\rightarrow}\f$ is the plane's normal vector and
+ * \f$D = - \stackrel{a}{\rightarrow} \stackrel{N}{\rightarrow}\f$, the offset with respect to origin, if \f$\stackrel{a}{\rightarrow}\f$,
+ * is an offset vector onto the plane. The line is parametrized by \f$\stackrel{x}{\rightarrow} + k \stackrel{t}{\rightarrow}\f$, where
+ * \f$\stackrel{x}{\rightarrow}\f$ is the offset and \f$\stackrel{t}{\rightarrow}\f$ the directional vector (NOTE: No need to normalize
+ * the latter). Inserting the parametrized form into the plane equation and solving for \f$k\f$, which we insert then into the parametrization
+ * of the line yields the intersection point on the plane.
+ * \param *Origin first vector of line
+ * \param *LineVector second vector of line
+ * \return true -  \a this contains intersection point on return, false - line is parallel to plane (even if in-plane)
+ */
+Vector Plane::GetIntersection(const Line& line) const
+{
+  Info FunctionInfo(__func__);
+  Vector res;
+
+  double factor1 = getNormal().ScalarProduct(line.getDirection());
+  if(fabs(factor1)<MYEPSILON){
+    // the plane is parallel... under all circumstances this is bad luck
+    // we no have either no or infinite solutions
+    if(isContained(line.getOrigin())){
+      throw MultipleSolutionsException<Vector>(__FILE__,__LINE__,line.getOrigin());
+    }
+    else{
+      throw LinearDependenceException(__FILE__,__LINE__);
+    }
+  }
+
+  double factor2 = getNormal().ScalarProduct(line.getOrigin());
+  double scaleFactor = (offset-factor2)/factor1;
+
+  res = line.getOrigin() + scaleFactor * line.getDirection();
+
+  // tests to make sure the resulting vector really is on plane and line
+  ASSERT(isContained(res),"Calculated line-Plane intersection does not lie on plane.");
+  ASSERT(line.isContained(res),"Calculated line-Plane intersection does not lie on line.");
+  return res;
+};
+
+Vector Plane::mirrorVector(const Vector &rhs) const {
+  Vector helper = getVectorToPoint(rhs);
+  // substract twice the Vector to the plane
+  return rhs+2*helper;
+}
+
+Line Plane::getOrthogonalLine(const Vector &origin) const{
+  return Line(origin,getNormal());
+}
+
+bool Plane::onSameSide(const Vector &point1,const Vector &point2) const{
+  return sign(point1.ScalarProduct(*normalVector)-offset) ==
+         sign(point2.ScalarProduct(*normalVector)-offset);
+}
+
+/************ Methods inherited from Space ****************/
+
+double Plane::distance(const Vector &point) const{
+  double res = point.ScalarProduct(*normalVector)-offset;
+  return fabs(res);
+}
+
+Vector Plane::getClosestPoint(const Vector &point) const{
+  double factor = point.ScalarProduct(*normalVector)-offset;
+  if(fabs(factor) < MYEPSILON){
+    // the point itself lies on the plane
+    return point;
+  }
+  Vector difference = factor * (*normalVector);
+  return (point - difference);
+}
+
+// Operators
+
+bool operator==(const Plane &x,const Plane &y){
+  return *x.normalVector == *y.normalVector && x.offset == y.offset;
+}
+
+ostream &operator << (ostream &ost,const Plane &p){
+  ost << "<" << p.getNormal() << ";x> - " << p.getOffset() << "=0";
+  return ost;
+}
Index: src/LinearAlgebra/Plane.hpp
===================================================================
--- src/LinearAlgebra/Plane.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/Plane.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,87 @@
+/*
+ * Plane.hpp
+ *
+ *  Created on: Apr 7, 2010
+ *      Author: crueger
+ */
+
+#ifndef PLANE_HPP_
+#define PLANE_HPP_
+
+#include <memory>
+#include <vector>
+#include <iosfwd>
+#include "LinearAlgebra/Space.hpp"
+#include "Exceptions/LinearDependenceException.hpp"
+#include "Exceptions/ZeroVectorException.hpp"
+
+class Vector;
+class Line;
+
+class Plane : public Space
+{
+  friend bool operator==(const Plane&,const Plane&);
+  typedef std::auto_ptr<Vector> vec_ptr;
+public:
+  Plane(const Vector &y1, const Vector &y2, const Vector &y3) throw(LinearDependenceException);
+  Plane(const Vector &y1, const Vector &y2, double _offset) throw(ZeroVectorException,LinearDependenceException);
+  Plane(const Vector &_normalVector, double _offset)  throw(ZeroVectorException);
+  Plane(const Vector &_normalVector, const Vector &_offsetVector) throw(ZeroVectorException);
+  Plane(const Plane& plane);
+  virtual ~Plane();
+
+  Plane &operator=(const Plane&);
+
+  // Accessor Functions
+  /**
+   * returns normal Vector for a plane
+   */
+  Vector getNormal() const;
+  /**
+   * returns the distance of the plane from the origin
+   */
+  double getOffset() const;
+  /**
+   * returns a vector that points on the plane.
+   * Same as getOffset()*getNormal();
+   */
+  Vector getOffsetVector() const;
+
+  /**
+   * returns three seperate points on this plane
+   */
+  std::vector<Vector> getPointsOnPlane() const;
+
+  // some calculations
+  Vector GetIntersection(const Line &Line) const;
+
+  Vector mirrorVector(const Vector &rhs) const;
+
+  /**
+   * get a Line that is orthogonal to this plane, going through a chosen
+   * point.
+   *
+   * The point does not have to lie on the plane itself.
+   */
+  Line getOrthogonalLine(const Vector &origin) const;
+
+  /**
+   * Test if two points are on the same side of the plane
+   */
+  bool onSameSide(const Vector&,const Vector&) const;
+
+  /****** Methods inherited from Space ***********/
+
+  virtual double distance(const Vector &point) const;
+  virtual Vector getClosestPoint(const Vector &point) const;
+
+private:
+  vec_ptr normalVector;
+  double offset;
+};
+
+bool operator==(const Plane&,const Plane&);
+
+std::ostream &operator<< (std::ostream &ost,const Plane& p);
+
+#endif /* PLANE_HPP_ */
Index: src/LinearAlgebra/Space.cpp
===================================================================
--- src/LinearAlgebra/Space.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/Space.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,42 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Space.cpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "LinearAlgebra/Space.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+Space::Space()
+{}
+
+Space::~Space()
+{}
+
+bool Space::hasZero() const{
+  return isContained(zeroVec);
+}
+
+Vector Space::getVectorToPoint(const Vector &origin) const{
+  Vector support = getClosestPoint(origin);
+  return support-origin;
+}
+
+bool Space::isContained(const Vector &point) const{
+  return (distance(point)) < MYEPSILON;
+}
